/* Imperative AVL trees, headers.
   Copyright (C) 2003-2005 Jean Goubault-Larrecq and LSV, CNRS UMR 8643
   & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct avlnode {
  ExprPtr key, val;
  ExprPtr left, right; /* bit 0 of these nodes is reserved:
			  if left bit 0 is set, then left is deeper
			  than right;
			  if right bit 0 is set, then right is deeper
			  than left;
			  left and right cannot have both their bit 0 set. */
};

#define AVL_LEFT(node) ((ExprPtr)(((long)node->left) & -2L))
#define AVL_RIGHT(node) ((ExprPtr)(((long)node->right) & -2L))
#define AVL_BIT_LEFT(node) (((long)node->left) & 1)
#define AVL_BIT_RIGHT(node) (((long)node->right) & 1)
#define AVL_SETBIT_LEFT(node) node->left = (ExprPtr)(((long)node->left) | 1L)
#define AVL_CLRBIT_LEFT(node) node->left = AVL_LEFT(node)
#define AVL_SETBIT_RIGHT(node) node->right = (ExprPtr)(((long)node->right) | 1L)
#define AVL_CLRBIT_RIGHT(node) node->right = AVL_RIGHT(node)
