/* Imperative tables, headers.
   Copyright (C) 2003-2005 Jean Goubault-Larrecq and LSV, CNRS UMR 8643
   & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define HN_USEFUL_BITS (NBITS_IN_ADDR - NLOWBITS)
#define HN_BITS (7)
#define HN_DEPTH ((HN_USEFUL_BITS+HN_BITS-1)/HN_BITS)
#define HN_BITS_LEAF (HN_USEFUL_BITS-(HN_DEPTH-1)*HN_BITS)

#define HN_MASK ((1<<HN_BITS) - 1)
#define HN_MASK_LEAF ((1<<HN_BITS_LEAF) - 1)

struct hnode {
  COUNTER n;
  struct hnode *sons [1<<HN_BITS];
  /* Only 1 << HN_BITS_LEAF for topmost hnode. */
};

#define SIZEOF_HNODE_LEAF (((char *)&((struct hnode *)NULL)->sons[1<<HN_BITS_LEAF]) - ((char *)(struct hnode *)NULL))

/* All this is buggy if HN_DEPTH<=1, i.e., HN_USEFUL_BITS<=1.
   This should not happen...
*/
