
(* test a few things about callcc/throw *)

ok "callcc" (callcc (fn k => 1)=1 andalso
	     let fun f k = 1 (* same test, but cont. handler is not explicit *)
	     in
		 callcc f=1
	     end andalso
	     (* now, test behavior of continuations to simulate exceptions *)
	     callcc (fn k => 3+throw k 5)=5 andalso
	     let fun f k = 3+throw k 5
	     in
		 callcc f=5
	     end andalso
	     (* time-warp through continuations: throw a continuation
	      after getting out of its lexically defining scope *)
	     let val r = ref NONE
		 val n = 1+callcc (fn k => (r := SOME k;
					    1))
	     in
		 if n=2
		     then case r of ref (SOME k) => throw k 3
		 else n
	     end = 4 andalso
	     (* callcc saves the stack of exception handlers,
	      so that the first handle Gag n below should be
	      seen after throwing. *)
	     let exception Gag of int
		 val r = ref NONE
		 val n = callcc (fn k => (r := SOME k;
					  identity)) 0
		     handle Gag n => n+1
	     in
		 if n=0
		     then case r of ref (SOME k) =>
			 throw k (fn n => raise Gag n) handle Gag n => n-1
		 else n
	     end = 1);
