(* Generation of fresh numbers and strings.
   Copyright (C) 1992-1995 Jean Goubault and Bull S.A.
   All rights reserved.

   Redistribution and use in source and binary forms are permitted provided
   that: (1) source distributions retain this entire copyright notice and
   comment, and (2) distributions including binaries display the following
   acknowledgement:  ``This product includes software developed by Jean
   Goubault as a contributor of Bull S.A.'' in the
   documentation or other materials provided with the distribution and in
   all advertising materials mentioning features or use of this software.
   Neither the name of Bull S.A. or of its corporate affiliates,
   nor the names of its contributors may be used to endorse or promote
   products derived from this software without specific prior written permission.
   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
   WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
*)

(* genint () generates a new integer each time,
 genstring str generates a new string with prefix str each time.
*)

local
	val counter = ref 0
in
	fun genint () = let val n = !counter in counter := n+1; n end
	fun genstring str =
	    let val s as |[put,convert,...]| = outstring str
	    in (* use file functions on strings to convert integer to string
		and append it to argument str. *)
		print (s,pack genint());
		convert ()
	    end
end
