/* Bytecode compiler auxiliary functions, headers.
   Copyright (C) 1995-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

typedef struct bcdState {
  bcBuffer *dcurrent;
  INT n;
  ExprPtr dz;
} bcdState;

IMPORT bcFile *bcOpen P((void));
IMPORT void bcPut P((IN OPCODE c, INOUT bcFile *f));
IMPORT INT bcTell P((IN CONST bcFile *f));
IMPORT void bcdPut P((IN OPCODE c, INOUT bcFile *f));
IMPORT INT bcdTell P((IN CONST bcFile *f));
IMPORT void bcdGetState P((IN CONST bcFile *f,OUT bcdState *st));
IMPORT void bcdRewindState P((INOUT bcFile *f,IN CONST bcdState *st));
IMPORT bcFile *bcOpenE P((IN CONST compEnv *env));
IMPORT void bcPatchJump P((IN INT addr,IN INT excess,INOUT bcFile *f));
IMPORT void bcPatchSwitchEntry P((IN INT addr,INOUT bcFile *f));
IMPORT void bcdPatch P((IN REGISTER INT addr,INOUT bcFile *f));
IMPORT void bccPut P((IN CONST ExprPtr e,INOUT bcFile *f));
#define bccTell(f) ((f)->cpos)
IMPORT void bcuPut P((IN CONST CHAR *data,IN INT size,IN INT align,INOUT bcFile *f));
IMPORT INT bcuTell P((IN CONST bcFile *f));
IMPORT ExprPtr bcClose P((IN bcFile *f));
IMPORT void bcPush P((IN COUNTER amount,IN bcFile *f));
IMPORT void bcMapPush P((IN COUNTER amount,IN bcFile *f));

IMPORT Boolean gotoOp0 P((INOUT OPCODE *opp));

IMPORT Boolean needEnv P((IN CONST ExprPtr code,INOUT compEnv *env));
IMPORT Boolean needEnvPattern P((IN CONST ExprPtr pat,INOUT compEnv *env));
IMPORT Boolean needEnvBindings P((IN CONST ExprPtr bindlist,INOUT compEnv *env));
IMPORT Boolean needEnvDoms P((IN CONST ExprPtr domlist,INOUT compEnv *env));

IMPORT MapPtr freeVars P((IN CONST ExprPtr code,INOUT compEnv *env));
