/* Interpreter initialization.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include "eval.h"
#include "expr.h"
#include "bc.h"
#include "iniproto.h"
#include "evlproto.h"
#ifdef HAS_PROTOTYPES
#include "sevlinit.h"
#endif

#define __SEG__ INIT

PUBLIC ExprPtr
  nomemException=NOEXPR,
  stackException,noninvException,
  nthException,rangeException,
  asciiException,stringnthException,
  nonsenseException,catchException,
  subscriptException,
  ioException,ufindException,futureException,
  reException,specialMarker;
PUBLIC excHandler *excStack;
EXTERN ExprPtr bindSym,matchSym,emptySym,mapgetSym,
  parsweepSym,nomemSym,stackSym,incompSym,noninvSym,
  nthSym,rangeSym,asciiSym,stringnthSym,nonsenseSym,
  subscriptSym,arithSym,ioSym,reSym,ufindSym,futureSym,
  catchSym;

PUBLIC void InitEval()
{
  ENTER;

  BINDEXC = MakeException(bindSym,EXC_BENIGN);
  MATCHEXC = MakeException(matchSym,EXC_BENIGN);
  EMPTYEXC = MakeException(emptySym,EXC_BENIGN);
  MAPGETEXC = MakeException(mapgetSym,EXC_BENIGN);
  MAPEXC= MakeException(parsweepSym,EXC_BENIGN);
  nomemException = MakeException(nomemSym,EXC_BENIGN);
  stackException = MakeException(stackSym,EXC_BENIGN);
  INCOMPEXC = MakeException(incompSym,EXC_BENIGN);
  noninvException = MakeException(noninvSym,EXC_BENIGN);
  nonsenseException = MakeException(nonsenseSym,EXC_BENIGN);
  futureException = MakeException(futureSym,EXC_BENIGN);
  catchException = MakeException(catchSym,EXC_BENIGN);
  nthException = MakeException(nthSym,EXC_BENIGN);
  rangeException = MakeException(rangeSym,EXC_BENIGN);
  asciiException = MakeException(asciiSym,EXC_BENIGN);
  stringnthException = MakeException(stringnthSym,EXC_BENIGN);
  subscriptException = MakeException(subscriptSym,EXC_BENIGN);
  ARITHEXC = MakeException(arithSym,EXC_BENIGN);
  ioException = MakeException(ioSym,EXC_BENIGN);
  reException = MakeException(reSym,EXC_BENIGN);
  ufindException = MakeException(ufindSym,EXC_BENIGN);
  specialMarker = MakeException(NIL,EXC_BENIGN);
  excStack = NULL;
  QUIT;
}
