/* Prototypes for parsing support functions.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#ifndef YYLTYPE
typedef
struct yyltype
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
  char *text;
} yyltype;

#define YYLTYPE yyltype
#endif

IMPORT ExprPtr ZBuild P((IN CONST TZone *zone,IN COUNTER f,IN CONST ExprPtr info));
IMPORT ExprPtr getString P((IN CONST struct yyltype *start,
			    IN CONST struct yyltype *end,
			    IN CHAR *text,IN Boolean build));

IMPORT void add_path P((char *name,int len));
IMPORT hFILE *xfopen P((char *name,char *mode,char **realname));

IMPORT int yyparse P((void));
IMPORT void InitLex P((void));
IMPORT void InitGram P((void));
IMPORT int yylex P((void));
IMPORT int skipOrwhen P((void));
IMPORT int skipOtherwise P((void));
IMPORT void skipThen P((void));

IMPORT void setConstructor P((IN CONST ExprPtr name));
IMPORT void popEnv P((void));
IMPORT void pushEnv P((void));
IMPORT ExprPtr copyLexEnv P((void));
IMPORT ExprPtr copyConsEnv P((void));
#if MODULE_SYSTEM & STD_ML_MODULE
IMPORT ExprPtr copyStrEnv P((void));
IMPORT ExprPtr copySigEnv P((void));
#endif

IMPORT int HimMLParse P((void));
IMPORT int HimMLCompile P((void));

IMPORT void StoreInitialBasis P((void));
