/* Definitions for Standard ML modules (unused).
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

/* A signature is a couple (E_TUPLE_2), containing:
   - a type_assum, summing up all declarations in the sig, with
   nongens=the set of all type, structure, signature and functor names
   in the sig.
   - a type_state, with:
   - tyvarsubs={},
   - noneqs=the set of type names
   that don't admit equality (including the ones that are declared
   'type t' instead of 'eqtype t' or 'dimension t')
   - packers={},
   - explicits={},
   - nongens={} (no free imperative type variables),
   A structure is also a couple (E_RECORD_1), containing:
   - a type_assum, summing up all declarations in the struct, with
   nongens containing no type, structure, signature or functor names
   - a type_state, with:
   - tyvarsubs containing also (type, structure, functor) name substitutions,
   - nongens={} (no free imperative type variables)
   A functor is a couple (sig,struct).
   A functor signature is a couple (sig,sig).
   */

#define	SIG_KIND	E_TUPLE_2
#define	STRUCT_KIND	E_RECORD_1
#define	FUNCTOR_KIND	E_LET

#define	STRUCT_ASSUM(s)	CAR(s)
#define	STRUCT_STATE(s)	CDR(s)

#define	MAKE_STRUCT(assum,state) MakePair(STRUCT_KIND,assum,state)

#define	SIG_ASSUM(s)	STRUCT_ASSUM(s)
#define	SIG_STATE(s)	STRUCT_STATE(s)

#define	MAKE_SIG(assum,state)	MakePair(SIG_KIND,assum,state)

#define	FUNCTOR_IN(f)	LETBIND(f)
#define	FUNCTOR_OUT(f)	LETBODY(f)

#define	MAKE_FUNCTOR(in,out)	MakeLet(in,out)
