/* Definitions for printing.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

IMPORT COUNTER printBuf P((IN CONST char *buf,IN printFunc doprint,char *printdata));
IMPORT COUNTER printComma1 P((IN printFunc doprint,char *printdata));
IMPORT COUNTER printComma P((IN printFunc doprint,char *printdata,INOUT Boolean *commap));
IMPORT Boolean prettyComma1 P((IN printFunc doprint,char *printdata,IN COUNTER lmargin));
IMPORT Boolean prettyComma P((IN printFunc doprint,char *printdata,INOUT Boolean *commap,
			      IN COUNTER lmargin));
IMPORT COUNTER printSym P((IN CONST SymPtr sym,IN printFunc doprint,char *printdata));
IMPORT COUNTER printOfType P((IN printFunc doprint,char *printdata));
IMPORT void printDot P((IN printFunc doprint,char *printdata,INOUT Boolean *commap));
IMPORT COUNTER printPower P((IN printFunc doprint,char *printdata));
IMPORT COUNTER printEtc P((IN printFunc doprint,char *printdata));
IMPORT COUNTER printOpenBrace P((IN printFunc doprint,char *printdata));
IMPORT COUNTER printCloseBrace P((IN printFunc doprint,char *printdata));
IMPORT COUNTER printOpenParen P((IN printFunc doprint, INOUT char *printdata));
IMPORT COUNTER printCloseParen P((IN printFunc doprint, INOUT char *printdata));
IMPORT COUNTER printSpace P((IN printFunc doprint,char *printdata));
IMPORT COUNTER printRecord0 P((IN printFunc doprint,char *printdata));
IMPORT COUNTER printOpenRecord P((IN printFunc doprint,char *printdata));
IMPORT COUNTER printCloseRecord P((IN printFunc doprint,char *printdata));
IMPORT COUNTER printEqual P((IN printFunc doprint,char *printdata));
IMPORT Boolean CrTab P((IN printFunc doprint,char *printdata,COUNTER lmargin));
PUBLIC COUNTER namePrint P((IN CONST SymPtr name,IN printFunc doprint,char *printdata));

#if IMPERATIVE_TYPES==EFFECT_TYVAR
IMPORT void fxReset P((void));
IMPORT void fxFlushPrint P((IN printFunc doprint,
			    INOUT char *printdata,
			    IN CONST ExprPtr state,IN Boolean comma));
IMPORT Boolean fxFlushPretty P((IN printFunc doprint,
				INOUT char *printdata,
				IN CONST ExprPtr state,
				IN COUNTER lmargin,IN COUNTER rmargin,
				IN Boolean comma,
				OUT Boolean *crp));
IMPORT Boolean fxFlush P((IN printFunc doprint,
		 	  INOUT char *printdata,IN CONST ExprPtr state));
IMPORT Boolean FxPretty P((IN CONST ExprPtr fx,
			   IN printFunc doprint,
			   INOUT char *printdata,
			   IN CONST ExprPtr state));
#else
#define fxReset()
#define fxFlushPrint(doprint,printdata,state,comma)
#define fxFlushPretty(doprint,printdata,state,lmargin,rmargin,comma,crp) (*crp = false, false)
#define fxFlush(doprint,printdata,state) false
#define FxPretty(fx,doprint,printdata,state) false
#endif
