/* Static structures for compaux.c.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

typedef ExprPtr permutationPtr; /* list of E_VARREF, with first node
				   having CAR pointing to start of list
				   and CDR to last node of list */

struct optswp {
  union {
    COUNTER i;
    ExprPtr lbl;
  } index;
  EXTENDED w,failw;
};

struct swprec {
  ExprPtr pat;
  struct optswp *swps,*swpp;
};

struct typeweight {
  EXTENDED sumw,prodw,prodfailw;
};

struct typeweightk {
  ExprPtr type;
  EXTENDED w,failw;
};

struct optmapadd {
  ExprPtr xy;
  EXTENDED w,failw;
};

struct optpatk {
  ExprPtr pat;
  EXTENDED w,failw;
};

struct renpatk {
  ExprPtr pat;
  permutationPtr p;
  COUNTER ilevel;
  COUNTER level;
  COUNTER shift;
  ExprPtr dbgnames;
};

struct renexprk {
  ExprPtr expr;
  permutationPtr p;
  COUNTER ilevel;
  COUNTER level;
  COUNTER shift;
};

struct matchpatrecmapadd {
  MapPtr map2;
  permutationPtr p;
  INT *np;
};

struct matchpatk {
  ExprPtr pat1;
  ExprPtr pat2;
  permutationPtr p;
  INT *np;
  Boolean res;
};

struct tackpatk {
  ExprPtr pats;
  ExprPtr pat;
  ExprPtr body;
  ExprPtr dbgnames;
  INT *np;
};

struct haschoice {
  ExprPtr pat;
  Boolean res;
};

struct getdbgnames {
  ExprPtr pat;
  MapPtr res;
};
