/* Static structures for debug.c.
   Copyright (C) 1998-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct snapshot {
  byteCodeChunk *bc;
  INT pc;
  ExprPtr *top;
  COUNTER stackDepth;
  COUNTER mapStackDepth;
  ExprPtr file;
  COUNTER line, pos;
  ExprPtr name;
  ExprPtr ids;
  MapPtr parent_dbgnames;
};

struct prtstrmax {
  COUNTER len,maxlen;
};

struct showargs {
  struct prtstrmax psmax;
  struct snapshot *snap;
};

#ifdef OBSOLETE
struct applStkPtr {
  ExprPtr ll; /* NOEXPR if pointing to applStkTable */
  COUNTER i; /* index in table */
};
#endif

struct sortinfos {
  ExprPtr code;
  ExprPtr listref;
};

struct getdz1 {
  ExprPtr code;
  SHORT cnt;
};

struct infn {
  ExprPtr polyfun;
  ExprPtr nestlist;
};

struct infn1 {
  ExprPtr polyfun;
  ExprPtr code;
  ExprPtr nestlist;
};

struct getfnname {
  ExprPtr polyfun;
  ExprPtr topenv;
  ExprPtr name;
  ExprPtr nest;
};

struct showbreak {
  INT i;
  ExprPtr msg;
};

struct parsevalue {
  int c;
  ExprPtr e;
  ExprPtr code;
};

struct dbgeval {
  struct snapshot *snap;
  ExprPtr e;
  ExprPtr type;
};

struct printdbgexpr {
  hFILE *f;
  ExprPtr e;
};

struct possiblerefinements {
  ExprPtr strings;
  COUNTER n;
};

typedef Boolean (*sweepBreaksFun) P((IN byteCodeChunk *bc, IN OPCODE *pc, INOUT char *data));
