/* Definitions for dumping functions.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#define CROSS_DEF 0xff
#define CROSS_REF 0xfe
#define SHORT_CROSS_DEF 0xfd
#define SHORT_CROSS_REF 0xfc

IMPORT void markData P((INOUT ExprPtr e));
EXTERN void (*markDataHook) P((INOUT ExprPtr e));

IMPORT void unmarkBucketLists P((void));

IMPORT void outChars P((IN CONST CHAR *s,IN COUNTER len));
IMPORT void inChars P((OUT CHAR *s,IN COUNTER len));

IMPORT void outInt P((IN INT n));
IMPORT INT inInt P((void));
IMPORT void outShort P((IN SHORT n));
IMPORT SHORT inShort P((void));

IMPORT void outInts P((IN CONST INT *p, IN INT n));
IMPORT void inInts P((INOUT INT *p, IN INT n));
IMPORT void outShorts P((IN CONST SHORT *p, IN INT n));
IMPORT void inShorts P((INOUT SHORT *p, IN INT n));

IMPORT void outReal P((IN REAL *x));
IMPORT void inReal P((OUT REAL *x));

IMPORT void outTransfer P((IN CONST ExprPtr e,IN printFunc doprint,
			   INOUT char *printdata,IN Boolean sortmaps));
IMPORT ExprPtr inTransfer P((IN readFunc doread,INOUT char *readdata));
